﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ProgressBar
{
    public partial class Form1 : Form
    {
        private BackgroundWorker backgroundWorker = null;

        public Form1()
        {
            InitializeComponent();

            this.progressBar.Minimum = 0;
            this.progressBar.Maximum = 100;

            this.button1.Click += new EventHandler(this.button1_Click);
            this.button2.Click += new EventHandler(this.button2_Click);
            this.button3.Click += new EventHandler(this.button3_Click);

            this.button1.Enabled = true;
            this.button3.Enabled = false;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.button1.Enabled = false;
            this.button3.Enabled = true;
            this.backgroundWorker = new BackgroundWorker();
            this.backgroundWorker.WorkerReportsProgress = true;
            this.backgroundWorker.ProgressChanged += new ProgressChangedEventHandler(backgroundWorker_ProgressChanged);
            this.backgroundWorker.DoWork += new DoWorkEventHandler(backgroundWorker_DoWork);
            this.backgroundWorker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(backgroundWorker_RunWorkerCompleted);
            this.backgroundWorker.RunWorkerAsync();
        }

        void backgroundWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            this.OnTaskComplete();
        }

        private void OnTaskComplete()
        {
            this.taskCanceled = false;
            this.progressBar.Value = 0;
            this.button1.Enabled = true;
            this.button3.Enabled = false;
        }

        void backgroundWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            BackgroundWorker worker = sender as BackgroundWorker;

            for ( int i = 0; i < 100; i ++ )
            {
                if ( this.taskCanceled )
                {
                    e.Cancel = true;
                    this.BeginInvoke( new MethodInvoker(this.OnTaskComplete) );
                    break;
                }

                System.Threading.Thread.Sleep( TimeSpan.FromSeconds(1) );
                worker.ReportProgress( i );
            }
        }

        void backgroundWorker_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            this.progressBar.Value = e.ProgressPercentage; 
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.listBox1.Items.Add( string.Format("Clicked at {0}", DateTime.Now.ToString("hh:mm:ss")) );
        }

        bool taskCanceled = false;
        private void button3_Click(object sender, EventArgs e)
        {
            this.taskCanceled = true;
        }

    }
}
